// Created by: X
// Web: http://www.createdbyx.com/
// Date: July 8, 2008
// =============================================

using System;
using System.IO;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using StreamContentProcessor.Properties;


// TODO: replace this with the type you want to import.
using TImport = System.IO.MemoryStream;

namespace StreamContentProcessor
{
    /// <summary>
    /// This class will be instantiated by the XNA Framework Content Pipeline
    /// to import a file from disk into the specified type, TImport.
    /// 
    /// This should be part of a Content Pipeline Extension Library project.
    /// 
    /// TODO: change the ContentImporter attribute to specify the correct file
    /// extension, display name, and default processor for this importer.
    /// </summary>
    [ContentImporter(new string[] { ".txt", ".xml"}, DisplayName = "Stream Importer - Createdbyx.com", DefaultProcessor = "StreamContentProcessor")]
    public class StreamImporter : ContentImporter<TImport>
    {
        public override TImport Import(string filename, ContentImporterContext context)
        {

            // declare a varible for storing the data contained in the file
            byte[] data = null;

            // report that asset processing has begun
            context.Logger.PushFile(filename);

            // try to read the file
            try
            {
                // read all file data as a string
                data = File.ReadAllBytes(filename);
            }
            catch (Exception ex)
            {
                // throw a InvalidContentException exception that reports the problem
                throw new InvalidContentException(Resources.CouldNotReadFile,
                                  new ContentIdentity(Path.GetFullPath(filename)), ex);
            }
            finally
            {
                // report that asset processing has completed
                context.Logger.PopFile();
            }

            // return the data that was read as a stream object.
            System.IO.MemoryStream stream = new System.IO.MemoryStream();
            stream.Write(data, 0, data.Length);
            data = null;

            return stream;
        }
    }
}
